/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.kintai.common.action.KintaiCommonAction;
import jp.mosp.kintai.common.dao.CmWorkTypeDao;
import jp.mosp.kintai.common.dto.CmWorkTypeDto;
import jp.mosp.system.vo.WorkTypeMasterCardVo;

/**
 * @author yoshida
 *
 */
public class WorkTypeMasterCardAction extends KintaiCommonAction {
	
	// コマンド
	private static final String	CMD_WORKTYPE_MASTER_CARD_SHOW	= "S2605";	// 表示(追加)
	private static final String	CMD_WORKTYPE_MASTER_CARD_SELECT	= "S2606";	// 表示(選択)
	private static final String	CMD_WORKTYPE_MASTER_CARD_INSERT	= "S2607";	// 登録
	private static final String	CMD_WORKTYPE_MASTER_CARD_UPDATE	= "S2608";	// 更新
																			
	// フィールド
	private CmWorkTypeDto		dto;
	

	/**
	 * コンストラクタ
	 */
	public WorkTypeMasterCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo();
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_SHOW)) {
			// 表示（新規登録）
			show();
		} else if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_WORKTYPE_MASTER_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new WorkTypeMasterCardVo();
	}
	
	/**
	 * Action初期処理
	 * @throws Exception 	例外処理が発生した場合
	 */
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		WorkTypeMasterCardVo vo = (WorkTypeMasterCardVo)getVo();
		vo.setParams(request);
	}
	
	@Override
	protected void show() {
		WorkTypeMasterCardVo vo = (WorkTypeMasterCardVo)getVo();
		vo.setDefaultValues();
		vo.setMode(WorkTypeMasterCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		WorkTypeMasterCardVo vo = (WorkTypeMasterCardVo)getVo();
		// 表示(キーで情報を検索)
		// データの取得
		dto = part().worktype().getCmWorkTypeDao().findForKey(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(WorkTypeMasterCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		WorkTypeMasterCardVo vo = (WorkTypeMasterCardVo)getVo();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		dto = new CmWorkTypeDto();
		vo.setDtoFields(dto);
		// DAOの準備
		CmWorkTypeDao dao = part().worktype().getCmWorkTypeDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getShiftCode()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		CmWorkTypeDto retDto = dao.findForKey(dto.getShiftCode());
		chkInsert(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(WorkTypeMasterCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		dto = (CmWorkTypeDto)getSessionDto();
		WorkTypeMasterCardVo vo = (WorkTypeMasterCardVo)getVo();
		// コード区分取得
		vo.setTxtShiftCode(dto.getShiftCode());
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		vo.setDtoFields(dto);
		// DAOの準備
		CmWorkTypeDao dao = part().worktype().getCmWorkTypeDao();
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getShiftCode()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		CmWorkTypeDto retDto = dao.findForKey(dto.getShiftCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(WorkTypeMasterCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
}
